(function() {
  var BaseQuery, Insert, InsertQuery, SelectQuery, Tuple, fluid, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  BaseQuery = require('./base-query');
  SelectQuery = require('./select');
  _ref = require('./nodes'), Insert = _ref.Insert, Tuple = _ref.Tuple;
  module.exports = InsertQuery = (function() {
    __extends(InsertQuery, BaseQuery);
    function InsertQuery() {
      InsertQuery.__super__.constructor.apply(this, arguments);
    }
    InsertQuery.prototype.addRows = fluid(function() {
      var row, rows, _i, _len, _results;
      rows = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      _results = [];
      for (_i = 0, _len = rows.length; _i < _len; _i++) {
        row = rows[_i];
        _results.push(this.q.addRow(row));
      }
      return _results;
    });
    InsertQuery.prototype.addRow = function(row) {
      return this.addRows(row);
    };
    InsertQuery.prototype.from = fluid(function(query) {
      switch (query.constructor) {
        case SelectQuery:
          return this.q.source = this.q.nodes[2] = query.q;
        case Select:
          return this.q.source = query;
        default:
          throw new Error("Can only insert from a SELECT");
      }
    });
    return InsertQuery;
  })();
  InsertQuery.into = function(tbl, fields, opts) {
    var iq;
    if (opts == null) {
      opts = {};
    }
    if (!fields && fields.length) {
      throw new Error("Column list is required when constructing an INSERT");
    }
    opts.table = tbl;
    iq = new InsertQuery(Insert, opts);
    iq.q.columns = iq.q.nodes[1] = new Tuple(fields);
    return iq;
  };
}).call(this);
