(function() {
  var Alias, And, Binary, ComparableMixin, DEFAULT, Delete, FixedNamedNodeSet, FixedNodeSet, GroupBy, Insert, InsertData, Join, JoinType, Limit, Node, NodeSet, Or, OrderBy, OrderBySet, Parameter, ParenthesizedNodeSet, Projection, ProjectionSet, Relation, RelationSet, Returning, Select, SelectProjectionSet, SqlFunction, Tuple, Update, UpdateSet, ValueNode, Where, copy, fluid, k, name, sqlFunction, toParam, toRelation, v, _i, _j, _len, _len2, _ref, _ref2, _ref3;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  Node = (function() {
    function Node() {}
    return Node;
  })();
  exports.ValueNode = ValueNode = (function() {
    __extends(ValueNode, Node);
    function ValueNode(value) {
      this.value = value;
    }
    ValueNode.prototype.copy = function() {
      return new this.constructor(this.value);
    };
    return ValueNode;
  })();
  exports.CONST_NODES = ['DEFAULT', 'NULL', 'IS_NULL', 'IS_NOT_NULL'];
  _ref = exports.CONST_NODES;
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    name = _ref[_i];
    exports[name] = new ValueNode(name.replace('_', ' '));
  }
  DEFAULT = exports.DEFAULT;
  JoinType = (function() {
    __extends(JoinType, ValueNode);
    function JoinType() {
      JoinType.__super__.constructor.apply(this, arguments);
    }
    return JoinType;
  })();
  exports.JOIN_TYPES = ['LEFT', 'RIGHT', 'INNER', 'LEFT_OUTER', 'RIGHT_OUTER', 'FULL_OUTER', 'NATURAL', 'CROSS'];
  _ref2 = exports.JOIN_TYPES;
  for (_j = 0, _len2 = _ref2.length; _j < _len2; _j++) {
    name = _ref2[_j];
    exports[name] = new JoinType(name.replace('_', ' '));
  }
  exports.NodeSet = NodeSet = (function() {
    __extends(NodeSet, Node);
    function NodeSet(nodes, glue) {
      this.nodes = nodes != null ? nodes : [];
      if (glue == null) {
        glue = ' ';
      }
      this.glue || (this.glue = glue);
    }
    NodeSet.prototype.copy = function() {
      var c;
      c = new this.constructor;
      c.nodes = copy(this.nodes);
      return c;
    };
    NodeSet.prototype.addNode = function() {
      var nodes, _ref3;
      nodes = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return (_ref3 = this.nodes).push.apply(_ref3, nodes);
    };
    NodeSet.prototype.params = function() {
      var node, params, _k, _len3, _ref3;
      params = [];
      _ref3 = this.nodes;
      for (_k = 0, _len3 = _ref3.length; _k < _len3; _k++) {
        node = _ref3[_k];
        if (node.params != null) {
          params = params.concat(node.params());
        } else if (node.constructor === Parameter) {
          params.push(node.value);
        }
      }
      return params;
    };
    return NodeSet;
  })();
  exports.FixedNodeSet = FixedNodeSet = (function() {
    __extends(FixedNodeSet, NodeSet);
    function FixedNodeSet(nodes, glue) {
      FixedNodeSet.__super__.constructor.call(this, nodes, glue);
      delete this.addNode;
    }
    return FixedNodeSet;
  })();
  exports.FixedNamedNodeSet = FixedNamedNodeSet = (function() {
    __extends(FixedNamedNodeSet, FixedNodeSet);
    function FixedNamedNodeSet() {
      var k, nodes, type;
      nodes = (function() {
        var _k, _len3, _ref3, _ref4, _results;
        _ref3 = this.structure;
        _results = [];
        for (_k = 0, _len3 = _ref3.length; _k < _len3; _k++) {
          _ref4 = _ref3[_k], k = _ref4[0], type = _ref4[1];
          _results.push(this[k] = new type);
        }
        return _results;
      }).call(this);
      FixedNamedNodeSet.__super__.constructor.call(this, nodes);
    }
    FixedNamedNodeSet.prototype.copy = function() {
      var c, i, k, _, _ref3, _ref4;
      c = FixedNamedNodeSet.__super__.copy.call(this);
      _ref3 = this.structure;
      for (i in _ref3) {
        _ref4 = _ref3[i], k = _ref4[0], _ = _ref4[1];
        c[k] = c.nodes[i];
      }
      return c;
    };
    return FixedNamedNodeSet;
  })();
  /* End of generic base classes */
  exports.SqlFunction = SqlFunction = (function() {
    __extends(SqlFunction, Node);
    function SqlFunction(name, arglist) {
      this.name = name;
      this.arglist = arglist;
    }
    SqlFunction.prototype.copy = function() {
      return new this.constructor(this.name, copy(this.arglist));
    };
    return SqlFunction;
  })();
  exports.sqlFunction = sqlFunction = function(name, args) {
    return new SqlFunction(name, new Tuple(args));
  };
  exports.Alias = Alias = (function() {
    __extends(Alias, Node);
    function Alias(obj, alias) {
      this.obj = obj;
      this.alias = alias;
    }
    Alias.prototype.copy = function() {
      return new this.constructor(copy(this.obj), this.alias);
    };
    Alias.prototype.project = function(name) {
      return new Projection(this, name);
    };
    Alias.prototype.field = function() {
      return this.project(arguments);
    };
    Alias.prototype.ref = function() {
      return this.alias;
    };
    return Alias;
  })();
  Alias.getAlias = function(o) {
    var keys;
    if ('object' === typeof o) {
      keys = Object.keys(o);
      if (keys.length === 1) {
        return keys.pop();
      }
    }
    return null;
  };
  exports.Parameter = Parameter = (function() {
    __extends(Parameter, ValueNode);
    function Parameter() {
      Parameter.__super__.constructor.apply(this, arguments);
    }
    return Parameter;
  })();
  exports.Relation = Relation = (function() {
    __extends(Relation, ValueNode);
    function Relation() {
      Relation.__super__.constructor.apply(this, arguments);
    }
    Relation.prototype.ref = function() {
      return this.value;
    };
    Relation.prototype.project = function(field) {
      return new Projection(this, field);
    };
    Relation.prototype.field = function(field) {
      return this.project(field);
    };
    Relation.prototype.copy = function() {
      return new this.constructor(this.value);
    };
    return Relation;
  })();
  exports.Limit = Limit = (function() {
    __extends(Limit, ValueNode);
    function Limit() {
      Limit.__super__.constructor.apply(this, arguments);
    }
    return Limit;
  })();
  exports.Binary = Binary = (function() {
    __extends(Binary, FixedNodeSet);
    function Binary(left, op, right) {
      this.left = left;
      this.op = op;
      this.right = right;
      Binary.__super__.constructor.call(this, [this.left, this.op, this.right], ' ');
    }
    Binary.prototype.copy = function() {
      return new this.constructor(copy(this.left), this.op, copy(this.right));
    };
    return Binary;
  })();
  exports.ParenthesizedNodeSet = ParenthesizedNodeSet = (function() {
    __extends(ParenthesizedNodeSet, NodeSet);
    function ParenthesizedNodeSet() {
      ParenthesizedNodeSet.__super__.constructor.apply(this, arguments);
    }
    return ParenthesizedNodeSet;
  })();
  exports.Tuple = Tuple = (function() {
    __extends(Tuple, ParenthesizedNodeSet);
    function Tuple() {
      Tuple.__super__.constructor.apply(this, arguments);
    }
    Tuple.prototype.glue = ', ';
    return Tuple;
  })();
  ProjectionSet = (function() {
    __extends(ProjectionSet, NodeSet);
    function ProjectionSet() {
      ProjectionSet.__super__.constructor.apply(this, arguments);
    }
    ProjectionSet.prototype.glue = ', ';
    return ProjectionSet;
  })();
  Returning = (function() {
    __extends(Returning, ProjectionSet);
    function Returning() {
      Returning.__super__.constructor.apply(this, arguments);
    }
    return Returning;
  })();
  SelectProjectionSet = (function() {
    __extends(SelectProjectionSet, ProjectionSet);
    function SelectProjectionSet() {
      SelectProjectionSet.__super__.constructor.apply(this, arguments);
    }
    SelectProjectionSet.prototype.prune = function(pred) {
      var node, orig, _results;
      orig = this.nodes;
      this.nodes = [];
      _results = [];
      for (node in orig) {
        _results.push(node instanceof Projection ? !pred(node) ? this.nodes.push(node) : void 0 : node instanceof Alias ? !pred(node.obj) ? this.nodes.push(node) : void 0 : void 0);
      }
      return _results;
    };
    return SelectProjectionSet;
  })();
  exports.Projection = Projection = (function() {
    __extends(Projection, FixedNodeSet);
    function Projection(source, field) {
      this.source = source;
      this.field = field;
      Projection.__super__.constructor.call(this, [this.source, this.field], '.');
    }
    Projection.prototype.copy = function() {
      return new this.constructor(copy(this.source), this.field);
    };
    return Projection;
  })();
  exports.RelationSet = RelationSet = (function() {
    __extends(RelationSet, NodeSet);
    function RelationSet() {
      RelationSet.__super__.constructor.apply(this, arguments);
    }
    RelationSet.prototype.start = function(first) {
      this.first = first;
      this.byName = {};
      this.nodes.unshift(this.first);
      this.byName[this.first.ref()] = this.active = this.first;
      return delete this.start;
    };
    RelationSet.prototype.registerName = function(node) {
      return this.byName[node.ref()] = node;
    };
    RelationSet.prototype.copy = function() {
      var c, first, node, rel, _k, _len3, _ref3;
      c = RelationSet.__super__.copy.call(this);
      if (first = c.nodes.shift()) {
        c.start(first);
      }
      _ref3 = c.nodes;
      for (_k = 0, _len3 = _ref3.length; _k < _len3; _k++) {
        node = _ref3[_k];
        rel = node.relation || node;
        c.registerName(rel);
      }
      if (first) {
        c.active = c.get(this.active);
      }
      return c;
    };
    RelationSet.prototype.get = function(name, strict) {
      var rel;
      if (strict == null) {
        strict = true;
      }
      if ('string' !== typeof name) {
        name = name.ref();
      }
      rel = this.byName[name];
      if (!rel && strict) {
        throw new Error("No such relation " + name + " in " + (Object.keys(this.byName)));
      }
      return rel;
    };
    RelationSet.prototype["switch"] = function(name) {
      if ('string' !== typeof name) {
        name = name.ref();
      }
      return this.active = this.byName[name];
    };
    return RelationSet;
  })();
  exports.Join = Join = (function() {
    __extends(Join, FixedNodeSet);
    function Join(type, relation, on) {
      var nodes;
      this.type = type;
      this.relation = relation;
      this.on = on;
      nodes = [this.type, 'JOIN', this.relation];
      if (this.on) {
        nodes.push('ON', this.on);
      }
      Join.__super__.constructor.call(this, nodes);
    }
    Join.prototype.copy = function() {
      return new this.constructor(this.type, copy(this.relation), copy(this.on));
    };
    return Join;
  })();
  exports.Where = Where = (function() {
    __extends(Where, NodeSet);
    function Where() {
      Where.__super__.constructor.apply(this, arguments);
    }
    Where.prototype.glue = ' AND ';
    return Where;
  })();
  exports.Or = Or = (function() {
    __extends(Or, ParenthesizedNodeSet);
    function Or() {
      Or.__super__.constructor.apply(this, arguments);
    }
    Or.prototype.glue = ' OR ';
    return Or;
  })();
  exports.And = And = (function() {
    __extends(And, ParenthesizedNodeSet);
    function And() {
      And.__super__.constructor.apply(this, arguments);
    }
    And.prototype.glue = ' AND ';
    return And;
  })();
  exports.GroupBy = GroupBy = (function() {
    __extends(GroupBy, NodeSet);
    function GroupBy(gs) {
      GroupBy.__super__.constructor.call(this, gs, ', ');
    }
    return GroupBy;
  })();
  exports.OrderBySet = OrderBySet = (function() {
    __extends(OrderBySet, NodeSet);
    function OrderBySet(os) {
      OrderBySet.__super__.constructor.call(this, os, ', ');
    }
    return OrderBySet;
  })();
  exports.OrderBy = OrderBy = (function() {
    __extends(OrderBy, FixedNodeSet);
    function OrderBy(projection, direction) {
      OrderBy.__super__.constructor.call(this, [projection, direction]);
    }
    return OrderBy;
  })();
  exports.UpdateSet = UpdateSet = (function() {
    __extends(UpdateSet, NodeSet);
    function UpdateSet(nodes) {
      UpdateSet.__super__.constructor.call(this, nodes, ', ');
    }
    return UpdateSet;
  })();
  exports.Select = Select = (function() {
    __extends(Select, FixedNamedNodeSet);
    Select.prototype.structure = [['projections', SelectProjectionSet], ['relations', RelationSet], ['where', Where], ['groupBy', GroupBy], ['orderBy', OrderBySet], ['limit', Limit]];
    function Select(rel) {
      Select.__super__.constructor.call(this);
      if (rel) {
        this.relations.start(rel);
      }
    }
    return Select;
  })();
  exports.Update = Update = (function() {
    __extends(Update, FixedNamedNodeSet);
    Update.prototype.structure = [['relation', Relation], ['updates', UpdateSet], ['orderBy', OrderBySet], ['limit', Limit], ['fromList', RelationSet], ['where', Where], ['returning', Returning]];
    function Update(rel) {
      Update.__super__.constructor.call(this);
      if (rel) {
        this.relation = this.nodes[0] = rel;
      }
    }
    return Update;
  })();
  InsertData = (function() {
    __extends(InsertData, NodeSet);
    function InsertData() {
      InsertData.__super__.constructor.apply(this, arguments);
    }
    InsertData.prototype.glue = ', ';
    return InsertData;
  })();
  exports.Insert = Insert = (function() {
    __extends(Insert, FixedNamedNodeSet);
    Insert.prototype.structure = [['relation', Relation], ['columns', Tuple], ['source', InsertData], ['returning', Returning]];
    function Insert(rel) {
      Insert.__super__.constructor.call(this);
      if (rel) {
        this.relation = this.nodes[0] = rel;
      }
    }
    Insert.prototype.addRow = function(row) {
      if (this.source.constructor === Select) {
        throw new Error("Cannot add rows when inserting from a SELECT");
      }
      if (row.constructor === Array) {
        return this.addRowArray(row);
      } else {
        return this.addRowObject(row);
      }
    };
    Insert.prototype.addRowArray = function(row) {
      var count, fields, n, params, v;
      if (!(count = this.columns.nodes.length)) {
        throw new Error("Must set column list before inserting arrays");
      }
      if (row.length !== count) {
        fields = (function() {
          var _k, _len3, _ref3, _results;
          _ref3 = this.columns.nodes;
          _results = [];
          for (_k = 0, _len3 = _ref3.length; _k < _len3; _k++) {
            n = _ref3[_k];
            _results.push(n);
          }
          return _results;
        }).call(this);
        throw new Error("Wrong number of values in array, expected " + fields);
      }
      params = (function() {
        var _k, _len3, _results;
        _results = [];
        for (_k = 0, _len3 = row.length; _k < _len3; _k++) {
          v = row[_k];
          _results.push(v instanceof Node ? v : new Parameter(v));
        }
        return _results;
      })();
      return this.source.addNode(new Tuple(params));
    };
    Insert.prototype.addRowObject = function(row) {
      var array, f;
      array = (function() {
        var _k, _len3, _ref3, _results;
        _ref3 = this.columns.nodes;
        _results = [];
        for (_k = 0, _len3 = _ref3.length; _k < _len3; _k++) {
          f = _ref3[_k];
          _results.push((row[f] != null) || row[f] === null ? row[f] : DEFAULT);
        }
        return _results;
      }).call(this);
      return this.addRowArray(array);
    };
    return Insert;
  })();
  exports.Delete = Delete = (function() {
    __extends(Delete, FixedNamedNodeSet);
    Delete.prototype.structure = [['relations', RelationSet], ['where', Where], ['orderBy', OrderBySet], ['limit', Limit]];
    function Delete(rel) {
      Delete.__super__.constructor.call(this);
      if (rel) {
        this.relations.start(rel);
      }
    }
    return Delete;
  })();
  ComparableMixin = (function() {
    function ComparableMixin() {}
    ComparableMixin.prototype.eq = function(other) {
      return new Binary(this, '=', toParam(other));
    };
    ComparableMixin.prototype.gt = function(other) {
      return new Binary(this, '>', toParam(other));
    };
    ComparableMixin.prototype.lt = function(other) {
      return new Binary(this, '<', toParam(other));
    };
    ComparableMixin.prototype.lte = function(other) {
      return new Binary(this, '<=', toParam(other));
    };
    ComparableMixin.prototype.gte = function(other) {
      return new Binary(this, '>=', toParam(other));
    };
    ComparableMixin.prototype.compare = function(op, other) {
      return new Binary(this, op, toParam(other));
    };
    return ComparableMixin;
  })();
  _ref3 = ComparableMixin.prototype;
  for (k in _ref3) {
    v = _ref3[k];
    Projection.prototype[k] = v;
    SqlFunction.prototype[k] = v;
  }
  exports.toParam = toParam = function(it) {
    if (it instanceof Node) {
      return it;
    } else if (Array.isArray(it)) {
      return new Tuple(it.map(toParam));
    } else {
      return new Parameter(it);
    }
  };
  exports.toRelation = toRelation = function(it) {
    var alias;
    switch (it.constructor) {
      case Relation:
      case Alias:
        return it;
      case String:
        return new Relation(it);
      case Object:
        if (alias = Alias.getAlias(it)) {
          return new Alias(new Relation(it[alias]), alias);
        } else {
          throw new Error("Can't make relation out of " + it);
        }
        break;
      default:
        throw new Error("Can't make relation out of " + it);
    }
  };
  copy = function(it) {
    var c, k, v, _results;
    if (!it) {
      return it;
    }
    switch (it.constructor) {
      case String:
      case Number:
      case Boolean:
        return it;
      case Array:
        return it.map(copy);
      case Object:
        c = {};
        _results = [];
        for (k in it) {
          v = it[k];
          _results.push(c[k] = copy(v));
        }
        return _results;
        break;
      default:
        if (it.copy != null) {
          return it.copy();
        } else {
          throw new Error("Don't know how to copy " + it);
        }
    }
  };
}).call(this);
