(function() {
  var Alias, And, INNER, Join, SUDQuery, Select, SelectQuery, fluid, sqlFunction, toRelation, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  SUDQuery = require('./sud-query');
  _ref = require('./nodes'), Alias = _ref.Alias, Select = _ref.Select, And = _ref.And, Join = _ref.Join, toRelation = _ref.toRelation, sqlFunction = _ref.sqlFunction, INNER = _ref.INNER;
  module.exports = SelectQuery = (function() {
    __extends(SelectQuery, SUDQuery);
    function SelectQuery(opts) {
      if (opts == null) {
        opts = {};
      }
      SelectQuery.__super__.constructor.call(this, Select, opts);
    }
    SelectQuery.prototype.fields = fluid(function() {
      var alias, f, fields, rel, _i, _len, _results;
      fields = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      if (fields[1] && Array.isArray(fields[1])) {
        rel = this.q.relations.get(fields[0]);
        if (rel == null) {
          unknown('table', fields[0]);
        }
        fields = fields[1];
      } else {
        rel = this.q.relations.active;
      }
      if (fields.length === 0) {
        this.q.projections.prune(function(p) {
          return p.source === rel;
        });
        return;
      }
      _results = [];
      for (_i = 0, _len = fields.length; _i < _len; _i++) {
        f = fields[_i];
        _results.push((alias = Alias.getAlias(f)) ? (f = f[alias], this.q.projections.addNode(new Alias(rel.project(f), alias))) : this.q.projections.addNode(rel.project(f)));
      }
      return _results;
    });
    SelectQuery.prototype.agg = fluid(function() {
      var fields, fun;
      fun = arguments[0], fields = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      return this.q.projections.addNode(sqlFunction(fun, fields));
    });
    SelectQuery.prototype.join = fluid(function(tbl, opts) {
      var joinClause, rel, type;
      if (opts == null) {
        opts = {};
      }
      rel = toRelation(tbl);
      if (this.q.relations.get(rel.ref(), false)) {
        throw new Error("Table/alias " + (rel.ref()) + " is not unique!");
      }
      type = opts.type || INNER;
      if (!(type instanceof INNER.constructor)) {
        throw new Error("Invalid join type " + type + ", try the constant types exported in the base module (e.g. INNER).");
      }
      joinClause = opts.on && new And(this.makeClauses(rel, opts.on));
      this.q.relations.addNode(new Join(type, rel, joinClause));
      this.q.relations.registerName(rel);
      this.q.relations["switch"](rel);
      if (opts.fields != null) {
        return this.fields.apply(this, opts.fields);
      }
    });
    SelectQuery.prototype.rel = function(alias) {
      return this.q.relations.get(alias);
    };
    SelectQuery.prototype.from = fluid(function(alias) {
      return this.q.relations["switch"](alias);
    });
    SelectQuery.prototype.groupBy = fluid(function() {
      var field, fields, rel, _i, _len, _results;
      fields = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      rel = this.q.relations.active;
      _results = [];
      for (_i = 0, _len = fields.length; _i < _len; _i++) {
        field = fields[_i];
        _results.push(field.constructor === String ? this.q.groupBy.addNode(rel.project(field)) : field instanceof Projection ? this.q.groupBy.addNode(field) : void 0);
      }
      return _results;
    });
    return SelectQuery;
  })();
  SelectQuery.prototype.field = SelectQuery.prototype.fields;
  SelectQuery.from = function(tbl, fields, opts) {
    var query;
    if (opts == null) {
      opts = {};
    }
    if ((fields != null) && fields.constructor !== Array) {
      opts = fields;
      fields = null;
    }
    opts.table = tbl;
    query = new SelectQuery(opts);
    if (fields != null) {
      query.fields.apply(query, fields);
    }
    return query;
  };
}).call(this);
