(function() {
  var BaseQuery, Or, OrderBy, SUDQuery, fluid, unknown, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  BaseQuery = require('./base-query');
  _ref = require('./nodes'), Or = _ref.Or, OrderBy = _ref.OrderBy;
  module.exports = SUDQuery = (function() {
    __extends(SUDQuery, BaseQuery);
    function SUDQuery() {
      SUDQuery.__super__.constructor.apply(this, arguments);
    }
    SUDQuery.prototype.where = fluid(function(alias, predicate) {
      var rel, _ref2;
      if (predicate != null) {
        rel = this.q.relations.get(alias);
        if (rel == null) {
          unknown('table', alias);
        }
      } else {
        predicate = alias;
        rel = this.defaultRel();
      }
      if (predicate.constructor !== Object) {
        return this.q.where.addNode(predicate);
      }
      return (_ref2 = this.q.where).addNode.apply(_ref2, this.makeClauses(rel, predicate));
    });
    SUDQuery.prototype.or = fluid(function() {
      var arg, args, clauses, rel, _i, _len;
      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      rel = this.defaultRel();
      clauses = [];
      for (_i = 0, _len = args.length; _i < _len; _i++) {
        arg = args[_i];
        clauses.push.apply(clauses, this.makeClauses(rel, arg));
      }
      return this.q.where.addNode(new Or(clauses));
    });
    SUDQuery.prototype.makeClauses = function(rel, predicate) {
      var clauses, constraint, field, op, val;
      clauses = [];
      for (field in predicate) {
        constraint = predicate[field];
        if (Object === constraint.constructor) {
          for (op in constraint) {
            val = constraint[op];
            clauses.push(rel.project(field).compare(op, val));
          }
        } else {
          clauses.push(rel.project(field).eq(constraint));
        }
      }
      return clauses;
    };
    SUDQuery.prototype.orderBy = fluid(function() {
      var args, dir, direction, field, name, orderBy, orderings, rel, _i, _j, _len, _len2, _ref2, _results;
      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      rel = this.defaultRel();
      orderings = [];
      for (_i = 0, _len = args.length; _i < _len; _i++) {
        orderBy = args[_i];
        switch (orderBy.constructor) {
          case String:
            orderings.push(orderBy.split(' '));
            break;
          case OrderBy:
            this.q.orderBy.addNode(orderBy);
            break;
          case Object:
            for (name in orderBy) {
              dir = orderBy[name];
              orderings.push([name, dir]);
            }
            break;
          default:
            throw new Error("Can't turn " + orderBy + " into an OrderBy object");
        }
      }
      _results = [];
      for (_j = 0, _len2 = orderings.length; _j < _len2; _j++) {
        _ref2 = orderings[_j], field = _ref2[0], direction = _ref2[1];
        direction = (function() {
          switch ((direction || '').toLowerCase()) {
            case 'asc':
            case 'ascending':
              return 'ASC';
            case 'desc':
            case 'descending':
              return 'DESC';
            case '':
              return '';
            default:
              throw new Error("Unsupported ordering direction " + direction);
          }
        })();
        _results.push(this.q.orderBy.addNode(new OrderBy(rel.project(field), direction)));
      }
      return _results;
    });
    SUDQuery.prototype.limit = fluid(function(l) {
      return this.q.limit.value = l;
    });
    SUDQuery.prototype.defaultRel = function() {
      return this.q.relations.active;
    };
    return SUDQuery;
  })();
  unknown = function(type, val) {
    throw new Error("Unknown " + type + ": " + val);
  };
}).call(this);
