(function() {
  var Binary, Parameter, SUDQuery, Update, UpdateQuery, fluid, _ref;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  }, __slice = Array.prototype.slice;
  fluid = require('./fluid');
  SUDQuery = require('./sud-query');
  _ref = require('./nodes'), Update = _ref.Update, Binary = _ref.Binary, Parameter = _ref.Parameter;
  module.exports = UpdateQuery = (function() {
    __extends(UpdateQuery, SUDQuery);
    function UpdateQuery() {
      UpdateQuery.__super__.constructor.apply(this, arguments);
    }
    UpdateQuery.prototype.set = fluid(function(data) {
      var field, value, _results;
      _results = [];
      for (field in data) {
        value = data[field];
        _results.push(this.q.updates.addNode(new Binary(field, '=', new Parameter(value))));
      }
      return _results;
    });
    UpdateQuery.prototype.setNodes = fluid(function() {
      var nodes, _ref2;
      nodes = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      return (_ref2 = this.q.updates).push.apply(_ref2, nodes);
    });
    UpdateQuery.prototype.setRaw = fluid(function(data) {
      var field, value, _results;
      _results = [];
      for (field in data) {
        value = data[field];
        _results.push(this.q.fields.push(field + ' = ' + value));
      }
      return _results;
    });
    UpdateQuery.prototype.defaultRel = function() {
      return this.q.relation;
    };
    return UpdateQuery;
  })();
  UpdateQuery.table = function(table, opts) {
    if (opts == null) {
      opts = {};
    }
    opts.table = table;
    return new UpdateQuery(Update, opts);
  };
}).call(this);
